/* Subroutines declaration */
void ServEcho(int sockfd);
/* Program beginning */
int main(int argc, char *argv[])
{
    int list_fd, conn_fd;
    pid_t pid;
    struct sockaddr_in serv_add;
     ...
    /* create socket */
    if ( (list_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        perror("Socket creation error");
        exit(-1);
    }
    /* initialize address */
    memset((void *)&serv_add, 0, sizeof(serv_add)); /* clear server address */
    serv_add.sin_family = AF_INET;                  /* address type is INET */
    serv_add.sin_port = htons(13);                  /* daytime port is 13 */
    serv_add.sin_addr.s_addr = htonl(INADDR_ANY);   /* connect from anywhere */
    /* bind socket */
    if (bind(list_fd, (struct sockaddr *)&serv_add, sizeof(serv_add)) < 0) {
        perror("bind error");
        exit(-1);
    }
    /* listen on socket */
    if (listen(list_fd, BACKLOG) < 0 ) {
        perror("listen error");
        exit(-1);
    }
    /* handle echo to client */
    while (1) {
        /* accept connection */
        if ( (conn_fd = accept(list_fd, NULL, NULL)) < 0) {
            perror("accept error");
            exit(-1);
        }
        /* fork to handle connection */
        if ( (pid = fork()) < 0 ){
            perror("fork error");
            exit(-1);
        }
        if (pid == 0) {      /* child */
            close(list_fd);          /* close listening socket */   
            SockEcho(conn_fd);       /* handle echo */
            exit(0);
        } else {             /* parent */
            close(conn_fd);          /* close connected socket */
        }
    }
    /* normal exit, never reached */
    exit(0);
}
